summaryrefslogtreecommitdiff
path: root/tests/ln
diff options
context:
space:
mode:
authorRémy Lefevre <lefevreremy@gmail.com>2013-04-02 02:48:28 +0100
committerPádraig Brady <P@draigBrady.com>2013-04-04 02:46:35 +0100
commite52293aa7fcf283758f97bc9bcc945707ccbce0a (patch)
treed663b5fd9420298f1032c623589fd23902f0d7e8 /tests/ln
parent20d7bce0f7e57d9a98f0ee811e31c757e9fedfff (diff)
downloadcoreutils-e52293aa7fcf283758f97bc9bcc945707ccbce0a.tar.xz
ln: --relative: fix updating of existing symlinks
Don't dereference an existing symlink being replaced. I.E. generate the symlink relative to the symlink's containing dir, rather than to some arbitrary place it points to. * src/ln.c (convert_abs_rel): Don't consider the final component of the symlink name when canonicalizing, as we want to avoid dereferencing the final component. * tests/ln/relative.sh: Add a test case. * NEWS: Mention the fix. Resolves http://bugs.gnu.org/14116
Diffstat (limited to 'tests/ln')
-rwxr-xr-xtests/ln/relative.sh5
1 files changed, 5 insertions, 0 deletions
diff --git a/tests/ln/relative.sh b/tests/ln/relative.sh
index 0418b8a04..818da8392 100755
--- a/tests/ln/relative.sh
+++ b/tests/ln/relative.sh
@@ -29,4 +29,9 @@ test $(readlink usr/bin/foo) = '../lib/foo/foo' || fail=1
ln -sr usr/bin/foo usr/lib/foo/link-to-foo
test $(readlink usr/lib/foo/link-to-foo) = 'foo' || fail=1
+# Correctly update an existing link, which was broken in <= 8.21
+ln -s dir1/dir2/f existing_link
+ln -srf here existing_link
+test $(readlink existing_link) = 'here' || fail=1
+
Exit $fail